/*
 * Copyright 2015 Christian Basler
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package ch.dissem.bitmessage.utils;

/**
 * Created by chris on 13.04.15.
 */
public class AccessCounter {
    private int count;

    public static void inc(AccessCounter counter) {
        if (counter != null) counter.inc();
    }

    public static void inc(AccessCounter counter, int count) {
        if (counter != null) counter.inc(count);
    }

    private void inc() {
        count++;
    }

    private void inc(int length) {
        count += length;
    }

    public int length() {
        return count;
    }

    @Override
    public String toString() {
        return String.valueOf(count);
    }
}
